--
--  Uwe R. Zimmer, Australia, 2014
--

--
--  Usage if the purpose is to "catch all":
--
--  begin
--   ..
--   exception
--      when Exception_Id : others => Show_Exception (Exception_Id);
--  end;
--

with Ada.Exceptions; use Ada.Exceptions;

package Exceptions is

   procedure Show_Exception (Exception_Identifier : Exception_Occurrence;
                             Optional_Message     : String := "");

   function Wrap_Exception (Original_Exception : Exception_Occurrence;
                            Optional_Message   : String := "") return String;

end Exceptions;
