with Ada.Exceptions;       use Ada.Exceptions;
with Ada.Task_Identification; use Ada.Task_Identification;
with Ada.Task_Termination; use Ada.Task_Termination;

package Scoped_Tasks_Finalizer is

   protected Finalizer is

      procedure Register (Id : Task_Id);

   private

      procedure Last_Wish (Cause : Cause_Of_Termination;
                           Id    : Task_Id;
                           X     : Exception_Occurrence);

   end Finalizer;

end Scoped_Tasks_Finalizer;
